//+------------------------------------------------------------------+
//|                                                     AMAstdev.mq4 |
//|                                 Copyright  2006, D&S kiriyenko. |
//|                 http://groups.google.com/group/expert-developing |
//+------------------------------------------------------------------+
#property copyright "Copyright  2006, D&S kiriyenko."
#property link      "http://groups.google.com/group/expert-developing"

#property indicator_chart_window
#property indicator_buffers 3
#property indicator_color1 LightGreen
#property indicator_width1 1
#property indicator_color2 Red
#property indicator_width2 2
#property indicator_color3 Blue
#property indicator_width3 2

//+------------------------------------------------------------------+
//|                                                  |
//+------------------------------------------------------------------+

//----  
#define INDICATOR_SHORT_NAME "AMAstdev"
#define MAIN "AMA line"
#define UP   "UpTrend point"
#define DOWN "DownTrend point"

//+------------------------------------------------------------------+
//|                                                 |
//+------------------------------------------------------------------+

//---- 
extern int       periodAMA = 9;   //  - 
extern int       nfast     = 2;   // EMA   
extern int       nslow     = 30;  // EMA   

//----   
extern double    Pow       = 2.0; //  

//----   
extern double    dK        = 1.0; //  

//+------------------------------------------------------------------+
//|                                              |
//+------------------------------------------------------------------+

//---- 
double kAMAbuffer[];
double kAMAupsig[];
double kAMAdownsig[];

//----   
int    cbars = 0, prevbars = 0, prevtime = 0;

//----  
double slowSC, fastSC;

//----  
double ddAMA[];

//+------------------------------------------------------------------+
//|                                  |
//+------------------------------------------------------------------+
bool InsertDif(double a)
  {
//---- ,   
   for (int i = 0; i < periodAMA; i++) //   
      if (ddAMA[i] == 0) //   
        {
         ddAMA[i] = a; //    
         return (true); //  
        }
//----   ,     
   for (i = 0; i < periodAMA-1;i++) //  ,  
      ddAMA[i] = ddAMA[i+1]; //    
   ddAMA[periodAMA-1] = a; //      
   return (true); //   
  }

//+------------------------------------------------------------------+
//|                                                     |
//+------------------------------------------------------------------+
int init()
  {
//---- 
//----  
   SetIndexBuffer(0,kAMAbuffer);
   SetIndexStyle(0,DRAW_LINE,0,2);
   SetIndexLabel(0,MAIN);
//----   
   SetIndexBuffer(1,kAMAupsig);
   SetIndexStyle(1,DRAW_ARROW);
   SetIndexArrow(1,159);
   SetIndexLabel(1,UP);
//----   
   SetIndexBuffer(2,kAMAdownsig);
   SetIndexStyle(2,DRAW_ARROW);
   SetIndexArrow(2,159);
   SetIndexLabel(2,DOWN);
//----  
   IndicatorDigits(4);
   string name = StringConcatenate(INDICATOR_SHORT_NAME,
                                   " (",periodAMA,"/",nfast,"/",nslow,")");
   IndicatorShortName(name);
//----  -    
   slowSC = (2.0 /(nslow+1)); // - 
   fastSC = (2.0 /(nfast+1)); // - 
//----  
   ArrayResize(ddAMA,periodAMA);
   ArrayInitialize(ddAMA,0.);
//---- 
   return(0);
  }

//+------------------------------------------------------------------+
//|                                                   |
//+------------------------------------------------------------------+
int deinit()
  {
   return(0);
  }

//+------------------------------------------------------------------+
//|                                               |
//+------------------------------------------------------------------+
int start()
  {
//----     
   if (prevbars == Bars) return(0); //   ,  
   cbars = IndicatorCounted(); //-  
   if (Bars <= (periodAMA+2)) return(0); //    
   if (cbars < 0) return(-1); //    
   if (cbars > 0) cbars--; //    
//----  
   int pos = Bars-cbars-periodAMA-2; //   
   double AMA0; // AMA
   if (cbars == 0) AMA0 = Close[pos+1]; // AMA  
//----  
   while (pos>=0)
     {
   //----  
      double signal = MathAbs(Close[pos]-Close[pos+periodAMA]); // 
   //----  
      double noise = 0.000000001;
      for (int i = 0;i<periodAMA;i++)
        {
         noise = noise + MathAbs(Close[pos+i]-Close[pos+i+1]); // 
        }
   //----   
      double ER = signal/noise; // 
      double SSC = ER*(fastSC-slowSC) + slowSC; // 
   //----   
      double AMA = AMA0 + (MathPow(SSC,Pow)*(Close[pos]-AMA0)); //
      kAMAbuffer[pos]=AMA; //
   //----   
      double ddK = (AMA - AMA0)/Point; //
      InsertDif(ddK); // 
      if (pos < Bars - 2*(periodAMA+2)) //   
        {
      //----   
         double SMAdif = 0; //  
         for (i = 0; i < periodAMA; i++)
           {
            SMAdif += ddAMA[i]; // 
           }
         SMAdif /= periodAMA; //   
      //----   
         double StDev = 0; //  
         for (i = 0; i < periodAMA; i++)
           {
            StDev += MathPow(ddAMA[i]-SMAdif,2); //  
           }
         StDev = MathSqrt(StDev)/periodAMA; //     
      //----  
         double Filter = dK*StDev;
      //----  
         if (ddK > Filter) kAMAupsig[pos] = AMA; //  
            else kAMAupsig[pos] = 0; //  
         if (ddK < -Filter) kAMAdownsig[pos] = AMA; //  
            else kAMAdownsig[pos] = 0; //   
        }
   //----    
      AMA0 = AMA; //   AMA
      pos--; //   
     }
//----
   prevbars=Bars;
   return(0);
  }

